/********************************************************************/
/* FIX_ICNS.C	first version created on 8-8-1992 by J. Klaren		*/
/* This source for Pure C may be distributed freely					*/
/* If you modify it please mark your alterations in the source and	*/
/* put your name in this header										*/
/********************************************************************/

#include <tos.h>
#include <aes.h>
#include <stddef.h>
#include <stdlib.h>

#define FNT_SIZ	6
#define TXT_W		(12 * FNT_SIZ)
#define TXT_H		(FNT_SIZ + 2)

#define FROM_START	0			/* seek modes for Fseek */
#define FROM_HERE		1
#define FROM_END		2

int handle;
char *buffer = NULL;

void do_exit( void )				/* exit function */
	{
	Fclose( handle );
	if( buffer != NULL )
		Mfree( buffer );
	}

int main( int argc, char *argv[] )
	{
	long		size = 0L,i;
	RSHDR		*hdr;
	OBJECT	*root;
	ICONBLK	*icon;
	OBJECT	*object;

	Cconws(	"Icon-resource fixer by J. Klaren\n\r\n"
				"This program is public domain\n\r"
				"You're free to: use it, copy it, modify it or\n\r"
				"whatever else springs to your mind....\n\r"
				"Don't forget: use it at your own risc!!\n\r" );

	if( argc != 2 )
		{
		Cconws( argv[0] );
		Cconws(
				": RSCFILE.RSC\n\r\n"
				"Where RSCFILE.RSC is a icons resource with ONLY one form with"
				"JUST icons\n\r"
				"Fixes icons in the resource for e.g. desktop icon resources.\n\r"
				"i.e. sets txt just beneath the icon and centers it\n\r\n"
				"Beware this program may destroy the resource file so make\n\r"
				"back-ups. (= USE AT YOUR OWN RISC)\n\r" );
		return 0;
		}

	handle = Fopen( argv[1], FO_RW );
	if( handle < 0 )
		{
		Cconws( "Couldn't open: " );
		Cconws( argv[1] );
		return handle;
		}

	atexit( do_exit );

	size = Fseek( 0, handle, FROM_END );

	if( (buffer = (char *)Malloc( size )) == NULL )
		{
		Cconws("Not enough memory to read resource\n\r");
		return 0;
		}

	Fseek( 0, handle, FROM_START );
	if( Fread( handle, size, buffer ) != size )
		{
		Cconws("Read error on resource\n\r");
		return 0;
		}

	hdr = (RSHDR *)buffer;

	if(( hdr->rsh_ntree != 1 ) || ( hdr->rsh_nted != 0 ) ||
		( hdr->rsh_nbb != 0 ) || ( hdr->rsh_nstring != 0 ) ||
		( hdr->rsh_nimages != 0 ) )
		{
		Cconws("This is no icons resource\n\r");
		return 0;
		}

	object =	(OBJECT *)(buffer + (long)hdr->rsh_object);
	root =	(OBJECT *)( buffer + 
				*(long *)( buffer + (long)hdr->rsh_trindex ));

	if( root->ob_head == -1 )
		{
		Cconws("Root object has no children\n\r");
		return 0;
		}

	for( i = root->ob_head; i <= root->ob_tail; i++ )
		{
		if( object[i].ob_type != G_ICON )
			{
			Cconws("Contains non-icons abort\n\r");
			return 0;
			}
		icon = (ICONBLK *)(buffer + object[i].ob_spec.index);

		object[i].ob_width = 9;
		object[i].ob_height = 0x0802;			/* 2 chars 8 pixels */

		icon->ib_xicon = (TXT_W - icon->ib_wicon) / 2;
		icon->ib_yicon = 0;
		icon->ib_wtext = TXT_W;
		icon->ib_htext = TXT_H;
		icon->ib_xtext = 0;
		icon->ib_ytext = icon->ib_hicon;
		}

	Fseek( 0, handle, FROM_START );
	Fwrite( handle, size, buffer );
	Fclose( handle );

	return 0;
	}
